package ModifyColumnMapping;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportViewer.Viewer;
import quadbase.reportdesigner.util.ColInfo;

public class ModifyColumnMapping extends Applet {

	static final long serialVersionUID = 1;

	public static void main(String[] args) {
		try {
			ModifyColumnMapping report = new ModifyColumnMapping();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", report.doModifyColumnMapping(frame));
			frame.addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setSize(800, 600);
			frame.setVisible(true);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	@Override
	public void init() {
		setLayout(new BorderLayout());
		add("Center", doModifyColumnMapping(this));
	}

	Component doModifyColumnMapping(Object parent) {

		// Do not use EspressManager
		QbReport.setEspressManagerUsed(false);

		// Open the template with backup data
		QbReport report = new QbReport(parent, // container 
				"ModifyColumnMapping.rpt", // template
				false, false, false, true);

		ColInfo[] newColumnMapping = new ColInfo[4];
		newColumnMapping[0] = new ColInfo(0);
		newColumnMapping[0].setRowBreak(true);
		newColumnMapping[1] = new ColInfo(1);
		newColumnMapping[1].setRowBreak(true);
		newColumnMapping[2] = new ColInfo(5);
		newColumnMapping[2].setAggregation(true, ColInfo.SUM);
		newColumnMapping[3] = new ColInfo(6);
		newColumnMapping[3].setAggregation(true, ColInfo.SUM);

		try {
			// Switch mapping
			report.getInputData().setMapping(newColumnMapping);

			// Refresh report
			report.refreshWithOriginalData();

			// Reapply template
			report.applyTemplate("ModifyColumnMapping.rpt");
		} catch (Exception ex)
		{
			ex.printStackTrace();
		}

		// Show report in Viewer
		return (new Viewer().getComponent(report));
	}
}
